Attribute VB_Name = "Module1"
Option Explicit

'********************* Deaths Compute noch auf DLL umstellen

'|--- Bugs ----------------------------------------------------------------|
'| 1. Lnderunabghngige Speicherung der Projekte                          |
'|-------------------------------------------------------------------------|

'|--- To-Do ---------------------------------------------------------------|
'| 1. Rates files lschen und umbenennen implementieren                    |
'| 2. Exakte CI implementieren                                               |
'| 3. PMR implementieren                                                   |
'| 4. CMF implementieren                                                   |
'| 5. SRR implementieren                                                   |
'| 6. POR implementieren                                                   |
'| 7. zeitabhngige Variablen implementieren                               |
'| 8. Spreedsheet grabbing fr rate files implementieren                   |
'| 9. ASCII-import verbessern                                             |
'|-------------------------------------------------------------------------|

'|--- Bug-Fixes in Version 1.1 --------------------------------------------|
'| 1. Wenn man ein Ratefile im Navigator anklickt und danach SMR_Compute   |
'|    erscheint falsche Tabelle (solved)                                   |
'| 2. Wenn die Raten alle Null sind bricht SMR Berechnung ab, da obs/0     |
'|    Division durch Null ist (solved)                                     |
'|-------------------------------------------------------------------------|

'|--- Neue Features in Version 1.1 ----------------------------------------|
'| 1. Kopiert markierte Bereiche einer Tabelle in die Zwischenablage       |
'| 2. PY- und Todeszahlen-Berechnung durch DLL                             |
'| 3. Lschen und umbennen von Projekten                                   |
'|-------------------------------------------------------------------------|

'|--- Fr die neue Hilfe-Datei --------------------------------------------|
'| Neue Fehlermeldung: "This project name exists already! You cannot       |
'|                      rename it."                                        |
'| Neue Warnings: "Expected number of deaths is zero."                     |
'|                "The number of observed deaths is zero."                 |
'|-------------------------------------------------------------------------|

Public blnProjectEdit As Boolean
 
Public PAMCOMPVersion  As String           'PAMCOMP Version
Public blnTextImport As Boolean            'False = TextImport fehlgeschlagen

Public strMainTable As String              'MainTable mit den Daten
Public intRateTablesAnzahl As Integer      'Anzahl der RateTables

Public strDatabase As String
Public strRecordsource As String
Public strConnect As String
Public strTablename As String

Public blnAgeOrCalendar As Boolean          'gibt an ob das Age(false) oder Calendar(true) Menu (frmSelfDefined) aufgerufen werden soll

Public selectedGrid As Object               'selektiertes MSFlexGrid (fr mnuTablesCopy)

'|------------------------|
'| Keys fr den Navigator |
'|------------------------|
Public AgeCalendarKey As String
Public Sex1AgeCalendarKey As String
Public Sex2AgeCalendarKey As String
Public DeathKey As String

Public selectedTable As String             'Gibt an welche Tabelle ausgewhlt wurde (wichtig frs exportieren)


'|-----------------------|
'|      PAM-Dateien      |
'|-----------------------|
Public blnPAMFileLoad As Boolean            'Gibt on ob eine PAM-Datei geladen wurde
Public strPamFile As String                 'Name der PAM-Datei (inklusive Pfad)
Public strTempPamFile As String             'Name der temporren PAM-Datei in der gearbeitet wird
Public blnPersonYears As Boolean            'Gibt an, ob Person Years in der PAM-Datei vorhanden sind
Public blnSex As Boolean                    'Gibt an, ob nach Geschlecht stratifiziert werden soll
Public blnLag As Boolean                    'Gibt an, ob ein Lag existiert
Public varSexStatus As Boolean              'Gibt an, ob alle Angaben fr die Geschlechtstratifizierung vorhanden sind
Public varLagStatus As Boolean              'Gibt an, ob alle Angaben fr den Lag vorhanden sind
Public intAnzahlTables As Integer           'Die Anzahl der vorhandenen Person-Years Tabellen


'|-----------------------|
'|   Projekt-Dateien     |
'|-----------------------|
Type ProjectTyp                             'Datentyp fr Projektdateien (zur SMR Berechnung)
 ProjectName As String                      'Name des Projekts
 RateTable As String                        'Tabellenname der Raten-Tabelle
 PyTable As Integer                         'Tabellenindex der PY-Tabelle (1=General, 2=varSex1, 3=varSex2)
 Alpha As String                            'Alpha-Level
 varDTH As String                           'Variable fr den Tod
 varTod As Integer                          'Variable, die den Wert fr Tod enthlt
 totTote As Long                            'Gesamtanzahl Tote
 totPy  As Double                           'Gesamtanzahl Person-Years
 totDthRate As Double                       'Gesamt Todesrate
 Expected As Double                         'Erwartet Todesflle
 Smr As Double                              'SMR
 Smr_l As Double                            'Unteres KI fr die SMR
 Smr_h As Double                            'Oberes KI fr die SMR
 n As Long                                  'Anzahl der Personen
 NInc As Long                               'Anzahl der Personen mit PY > 0 (fr Lag wichtig)
 varLag As Integer                          'Lag-Years
End Type

Public Project As ProjectTyp                'Datentyp ProjectTyp zuweisen
Public intProjectAnzahl As Integer          'Anzahl der Projekt-Dateien

Public strPAMFileVersion As String          'Version der PAM-Datei

Public SpaltenNamen() As String             'Array mit den Tabellenspalten: 1. Dim: 1=Name, 2=Typ (numeric, date)

'|-------------------------|
'| Person-Years Berechnung |
'|-------------------------|
Public varEPS As String                     'Entry-Point-of-Study
Public varTPS As String                     'Termination-Point-of-Study
Public varDOB As String                     'Date-of-Birth
Public varSEX As String                     'Variable fr das Geschlecht
Public varSex1 As Integer                   'Variable, die den Wert fr Sex=1 enthlt
Public varSex2 As Integer                   'Variable, die den Wert fr Sex=2 enthlt
Public varNInc As Long                      'Anzahl der Personen mit PY > 0 (fr Lag wichtig)

Public varAgeFrom As Integer                'von Altersklasse
Public varAgeTo As Integer                  'bis Altersklasse
Public varAgeStep As Integer                'Schrittweite
Public maxAgeClass As Integer               'Anzahl von Altersklassen
Public blnAgeSelfDefined As Boolean         'Gibt an, ob nach Alter selbst stratifiziert wurde
Public ageclass() As Integer                'Array mit den Altersklassen

Public varCalendarFrom As Integer           'von Kalenderjahr
Public varCalendarTo As Integer             'bis Klaenderjahr
Public varCalendarStep As Integer           'Schrittweite
Public maxYearClass As Integer              'Anzahl der Kalenderklassen
Public blnCalendarSelfDefined As Boolean    'Gibt an, ob nach Kalendarjahr selbst stratifiziert wurde
Public yearclass() As Integer               'Array mit den Kalenderklassen

Public py() As Long                         'Matrix mit den Person-Years: (sex*age*calendar)
Public dth() As Long                        'Matrix mit den Todeszahlen:  (age*calendar)
Public tempPy() As Long                     'Temporre Matrix mit den Person-Years

Public varLag As Integer                    'Variable, die den Wert fr den Lag enthlt <= 100
Public varDOH As String                     'Variable, die das DOH enthlt fr die Lag Berechnung

'|-------------------------|
'|     Message Array       |
'|-------------------------|
Public strMSG(100) As String                   'Das Message Array


'|-------------------------|
'|       Sonstiges         |
'|-------------------------|
Public ProgressCancel As Boolean            'Gibt an, ob die Berechnung der PY abgebrochen werden soll
Public blnProgress As Boolean               'Gibt an, ob Berechnung der PY gerade luft

Public nodeX As Node                        'Defintion fr den Projekt-Explorer

         
'Fr den Aufruf der Homepage sowie e-mail
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, _
                ByVal lpOperation As String, ByVal lpFile As String, _
                ByVal lpParameters As String, ByVal lpDirectory As String, _
                ByVal nShowCmd As Long) As Long
                
'Fr die Py-Berechnung via DLL
Public Declare Function PYCOMPUTE Lib "pamcomp.dll" Alias "_PYCOMPUTE@48" _
  (ByVal dblEPS As Double, ByVal dblTPS As Double, ByVal dblDOB As Double, _
   ByRef py As Double, ByVal pyAnzahl As Long, _
   ByRef ageclass As Double, ByVal ageAnzahl As Integer, _
   ByRef yearclass As Double, ByVal yearAnzahl As Integer) As Double
   
'Fr die Totenberechnung via DLL
Public Declare Function DEATHCOMPUTE Lib "pamcomp.dll" Alias "_DEATHCOMPUTE@40" _
  (ByVal dblTPS As Double, ByVal dblDOB As Double, _
   ByRef dth As Double, ByVal dthAnzahl As Long, _
   ByRef ageclass As Double, ByVal ageAnzahl As Integer, _
   ByRef yearclass As Double, ByVal yearAnzahl As Integer) As Double





Sub Main()
 ' DataMain         Verbindung mit der MainTable
 ' DataInternal     Vebindung mit der PamSystemMain Tabelle
 ' DataExternal     andere Verbindungen
 
  Screen.MousePointer = 11
   frmSplash.Show
   frmSplash.Refresh
   
  'Message Array
   strMSG(1) = "This PAMCOMP file has not the correct file version!"
   strMSG(2) = "You must select a variable for date-of-birth!"
   strMSG(3) = "You must select a variable for entry-point-of-study!"
   strMSG(4) = "You must select a variable for termination-point-of-study!"
   strMSG(5) = "The variable date-of-birth must be of type date!"
   strMSG(6) = "The variable entry-point-of-study must be of type date!"
   strMSG(7) = "The variable termination-point-of-study must be of type date!"
   strMSG(8) = "Incorrect stratification by sex!"
   strMSG(9) = "Incorrect lag definition!"
   strMSG(10) = "Inconsistent age class definition!"
   strMSG(11) = "Inconsistent calendar class definition!"
   strMSG(12) = "No age class defined!"
   strMSG(13) = "No calendar class defined!"
   strMSG(14) = "The date-of-hire variable must be of type date!"
   strMSG(15) = "The lag must range between 0 and 100 years!"
   strMSG(16) = "There is no PAMCOMP file loaded!"
   strMSG(17) = "There is no main data table for person-years computation!"
   strMSG(18) = "You must first calculate person-years!"
   strMSG(19) = "Do you want to save your changes?"
   strMSG(20) = "Main data table already exists!"
   strMSG(21) = "Do you really want to cancel?"
   strMSG(22) = ""
   strMSG(23) = ""
   strMSG(24) = "You must enter two values separated by a comma!"
   strMSG(25) = "The sex variable must be numeric!"
   strMSG(26) = "You must enter numeric values in the field 'Values'!"
   strMSG(27) = "The sex values must range between 0 and 32767!"
   strMSG(28) = "You must select a rate table!"
   strMSG(29) = "You must select a person-years table!"
   strMSG(30) = "You must select a death variable!"
   strMSG(31) = "The death variable must be numeric!"
   strMSG(32) = "You must enter a numeric value in the field 'Value'!"
   strMSG(33) = "The death value must range between 0 and 32767!"
   strMSG(34) = "Rate file is not conform to person-year table!"
   strMSG(35) = "This project name exists already! You cannot rename it."
   strMSG(36) = "The expected number of deaths is zero!"
   strMSG(37) = "The observed number of deaths is zero!"
        
   
   strPAMFileVersion = "1.0"
   PAMCOMPVersion = "1.10"
      
   intProjectAnzahl = 0
   
      
   frmMain.MainGrid.Visible = False
   
   frmMain.mnuProject.Visible = False
   
   frmMain.mnuTablesSaveAS.Enabled = False
   frmMain.mnuTablesCopy.Enabled = False
   frmMain.Toolbar1.Buttons("Copy").Enabled = False
   
   
  Set nodeX = frmMain.Navigator.Nodes.Add(, , "Main", "Main", 1, 2)
  Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "DATA", "Data", 1, 2)
  Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "RATE", "Rate tables", 1, 2)
  Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "PY", "Person-Years", 1)
  
   frmMain.Caption = "PAMCOMP " & PAMCOMPVersion
   frmMain.Show
   
   Unload frmSplash
   Screen.MousePointer = 0
End Sub







Public Sub ComputeAgeClass(vStart As Integer, vEnd As Integer, vStep As Integer)
'|-----------------------------------------------|
'| Berechnet die Altersklassen                   |
'|-----------------------------------------------|

 Dim i As Integer

 If vStep = 0 Then Exit Sub
 
 maxAgeClass = (vEnd - vStart) / vStep + 1
 
 ReDim ageclass(maxAgeClass) As Integer
 
 ageclass(1) = vStart
 
 For i = 2 To maxAgeClass
  ageclass(i) = ageclass(i - 1) + vStep
 Next i
 
End Sub

Public Sub ComputeYearClass(vStart As Integer, vEnd As Integer, vStep As Integer)

 Dim i As Integer
 
 If vStep = 0 Then Exit Sub
   
 maxYearClass = (vEnd - vStart) / vStep + 1
  
 
 ReDim yearclass(maxYearClass) As Integer
 
 yearclass(1) = vStart
 
 For i = 2 To maxYearClass
  yearclass(i) = yearclass(i - 1) + vStep
 Next i
 
 End Sub

Public Sub ShowPersonYears(index As Integer)
Dim i As Long
Dim j As Long

frmMain.ResultGrid.Cols = maxYearClass
frmMain.ResultGrid.Rows = maxAgeClass

frmMain.ResultGrid.TextMatrix(0, 0) = "Age class"

For i = 1 To maxYearClass - 1
 frmMain.ResultGrid.TextMatrix(0, i) = yearclass(i) & " - " & yearclass(i + 1) - 1
Next i

For i = 1 To maxAgeClass - 1
 frmMain.ResultGrid.TextMatrix(i, 0) = ageclass(i) & " - " & ageclass(i + 1) - 1
Next i

For i = 1 To maxAgeClass - 1
 For j = 1 To maxYearClass - 1
  frmMain.ResultGrid.TextMatrix(i, j) = CStr(Format(py(index, i, j) / 365.25, "0.00;;0"))
 Next j
Next i

'If frmMain.ResultGrid.Rows >= 8 Then
' frmMain.ResultGrid.Row = 9
'End If
'frmMain.ResultGrid.CellBackColor = vbWhite
'frmMain.ResultGrid.CellForeColor = vbBlack

If frmMain.ResultGrid.Rows >= 8 Then
 frmMain.ResultGrid.Row = 9
 frmMain.ResultGrid.CellBackColor = vbWhite
 frmMain.ResultGrid.CellForeColor = vbBlack
End If
If frmMain.ResultGrid.Rows >= 9 Then
 frmMain.ResultGrid.Row = 10
 frmMain.ResultGrid.CellBackColor = vbWhite
 frmMain.ResultGrid.CellForeColor = vbBlack
End If
If frmMain.ResultGrid.Rows >= 10 Then
 frmMain.ResultGrid.Row = 11
 frmMain.ResultGrid.CellBackColor = vbWhite
 frmMain.ResultGrid.CellForeColor = vbBlack
End If

Call ShowTables("ResultGrid")

End Sub

Public Sub ShowTables(tabelle As String)
 Dim i As Long
 Dim j As Long

 Select Case tabelle
  Case "Empty"
   Set selectedGrid = Nothing
   frmMain.Picture1.Visible = True
   frmMain.MainGrid.Visible = False
   frmMain.ResultGrid.Visible = False
   frmMain.InternalGrid.Visible = False
  Case "MainGrid"
   Set selectedGrid = frmMain.MainGrid
   frmMain.Picture1.Visible = False
   frmMain.MainGrid.Visible = True
   frmMain.ResultGrid.Visible = False
   frmMain.InternalGrid.Visible = False
   
   'Anzeige im vierstelligem Datumsformat
   For i = 0 To frmMain.DataMain.Recordset.fields.Count - 1
    If IsDate(frmMain.DataMain.Recordset.fields(i)) = True Then
     For j = 1 To frmMain.DataMain.Recordset.RecordCount
     frmMain.MainGrid.TextMatrix(j, i + 1) = Format(frmMain.MainGrid.TextMatrix(j, i + 1), "dd.mm.yyyy")
     Next j
    End If
   Next i
   
  Case "ResultGrid"
   Set selectedGrid = frmMain.ResultGrid
   frmMain.Picture1.Visible = False
   frmMain.MainGrid.Visible = False
   frmMain.ResultGrid.Visible = True
   frmMain.InternalGrid.Visible = False
  Case "InternalGrid"
   Set selectedGrid = frmMain.InternalGrid
   frmMain.Picture1.Visible = False
   frmMain.MainGrid.Visible = False
   frmMain.ResultGrid.Visible = False
   frmMain.InternalGrid.Visible = True
  End Select
End Sub



Public Sub ShowDeaths(tabelle As String)
Dim i As Long
Dim j As Long

With frmMain.DataInternal
 .DatabaseName = strTempPamFile
 .RecordSource = tabelle
 .Refresh
End With


frmMain.ResultGrid.Cols = maxYearClass
frmMain.ResultGrid.Rows = maxAgeClass

frmMain.ResultGrid.TextMatrix(0, 0) = "Age class"

For i = 1 To maxYearClass - 1
 frmMain.ResultGrid.TextMatrix(0, i) = yearclass(i) & " - " & yearclass(i + 1) - 1
Next i

For i = 1 To maxAgeClass - 1
 frmMain.ResultGrid.TextMatrix(i, 0) = ageclass(i) & " - " & ageclass(i + 1) - 1
Next i

  
For i = 1 To maxAgeClass - 1
 For j = 1 To maxYearClass - 1
   frmMain.ResultGrid.TextMatrix(i, j) = frmMain.DataInternal.Recordset.fields("Deaths")
   frmMain.DataInternal.Recordset.MoveNext
 Next j
Next i

'If frmMain.ResultGrid.Rows >= 8 Then
' frmMain.ResultGrid.Row = 9
'End If
'frmMain.ResultGrid.CellBackColor = vbWhite
'frmMain.ResultGrid.CellForeColor = vbBlack

If frmMain.ResultGrid.Rows >= 8 Then
 frmMain.ResultGrid.Row = 9
 frmMain.ResultGrid.CellBackColor = vbWhite
 frmMain.ResultGrid.CellForeColor = vbBlack
End If
If frmMain.ResultGrid.Rows >= 9 Then
 frmMain.ResultGrid.Row = 10
 frmMain.ResultGrid.CellBackColor = vbWhite
 frmMain.ResultGrid.CellForeColor = vbBlack
End If
If frmMain.ResultGrid.Rows >= 10 Then
 frmMain.ResultGrid.Row = 11
 frmMain.ResultGrid.CellBackColor = vbWhite
 frmMain.ResultGrid.CellForeColor = vbBlack
End If


Call ShowTables("ResultGrid")

End Sub

Public Sub OpenExternalFile(title As String)
On Error GoTo ErrorHandling
 
 Dim fname As String
 Dim fpath As String
 Dim file As String
 Dim tdf As TableDef
 
 With frmMain.dlgCommonDialog
   .DialogTitle = title
   .InitDir = CurDir
   .FileName = "*.txt"
   .Filter = "ASCII files (*.txt)|*.txt|" & _
             "Access 1.0 (*.mdb)|*.mdb|Access 1.1 (*.mdb)|*.mdb|Access 2.0 (*.mdb)|*.mdb|Access 7.0 (*.mdb)|*.mdb|Access 8.0 (*.mdb)|*.mdb|" & _
             "dBase III (*.dbf)|*.dbf|dBase IV (*.dbf)|*.dbf|dBase 5.0 (*.dbf)|*.dbf|" & _
             "Excel 3.0 (*.xls)|*.xls|Excel 4.0 (*.xls)|*.xls|Excel 5.0 (*.xls)|*.xls|Excel 7.0 (*.xls)|*.xls|Excel 8.0 (*.xls)|*.xls|" & _
             "Paradox 3.x (*.db)|*.db|Paradox 4.x (*.db)|*.db|Paradox 5.x (*.db)|*.db|"
   .FilterIndex = 1
   .DefaultExt = "*"
   .Flags = cdlOFNHideReadOnly + cdlOFNFileMustExist + cdlOFNNoReadOnlyReturn
   .CancelError = True
   .ShowOpen
 End With
 
  
 If Err = 0 Then
  Screen.MousePointer = 11
   ShowTables ("Empty")
   
    file = frmMain.dlgCommonDialog.FileName
    fname = file
    While InStr(fname, "\")
     fname = Mid$(fname, InStr(fname, "\") + 1)
    Wend
     fpath = Left(file, Len(file) - Len(fname))
     
  Select Case frmMain.dlgCommonDialog.FilterIndex
   Case 1       'ASCII
     strConnect = "Text;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 4)
   Case 2, 3, 4, 5, 6     'Access 1.0, 1.1, 2.0, 7.0, 8.0
     strConnect = ""
     strDatabase = frmMain.dlgCommonDialog.FileName
     frmMain.DataExternal.DatabaseName = strDatabase
     frmMain.DataExternal.connect = strConnect
     frmMain.DataExternal.Refresh
     frmSelectExternalTable.Show 1
     frmMain.DataExternal.Database.Close
     If strTablename = "" Then
      strConnect = ""
      strDatabase = ""
      strRecordsource = ""
      Exit Sub
     End If
   Case 7       'dBase III
     strConnect = "dBASE III;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 4)
   Case 8       'dBase IV
     strConnect = "dBASE IV;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 4)
   Case 9       'dBase 5
     strConnect = "dBase 5.0;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 4)
   Case 10       'Excel 3.0
     strConnect = "Excel 3.0;"
     strDatabase = frmMain.dlgCommonDialog.FileName
     frmMain.DataExternal.DatabaseName = strDatabase
     frmMain.DataExternal.connect = strConnect
     frmMain.DataExternal.Refresh
     frmSelectExternalTable.Show 1
     frmMain.DataExternal.Database.Close
     If strTablename = "" Then
      strConnect = ""
      strDatabase = ""
      strRecordsource = ""
      Exit Sub
     End If
   Case 11       'Excel 4.0
     strConnect = "Excel 4.0;"
     strDatabase = frmMain.dlgCommonDialog.FileName
     frmMain.DataExternal.DatabaseName = strDatabase
     frmMain.DataExternal.connect = strConnect
     frmMain.DataExternal.Refresh
     frmSelectExternalTable.Show 1
     frmMain.DataExternal.Database.Close
     If strTablename = "" Then
      strConnect = ""
      strDatabase = ""
      strRecordsource = ""
      Exit Sub
     End If
   Case 12, 13     'Excel 5.0 oder Excel 7.0
     strConnect = "Excel 5.0;"
     strDatabase = frmMain.dlgCommonDialog.FileName
     frmMain.DataExternal.DatabaseName = strDatabase
     frmMain.DataExternal.connect = strConnect
     frmMain.DataExternal.Refresh
     frmSelectExternalTable.Show 1
     frmMain.DataExternal.Database.Close
     If strTablename = "" Then
      strConnect = ""
      strDatabase = ""
      strRecordsource = ""
      Exit Sub
     End If
   Case 14     'Excel 8.0
     strConnect = "Excel 8.0;"
     strDatabase = frmMain.dlgCommonDialog.FileName
     frmMain.DataExternal.DatabaseName = strDatabase
     frmMain.DataExternal.connect = strConnect
     frmMain.DataExternal.Refresh
     frmSelectExternalTable.Show 1
     frmMain.DataExternal.Database.Close
     If strTablename = "" Then
      strConnect = ""
      strDatabase = ""
      strRecordsource = ""
      Exit Sub
     End If
  Case 15       'Paradox 3.x
     strConnect = "Paradox 3.x;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 3)
  Case 16       'Paradox 4.x
     strConnect = "Paradox 4.x;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 3)
  Case 17       'Paradox 5.x
     strConnect = "Paradox 5.x;"
     strDatabase = fpath
     strRecordsource = frmMain.dlgCommonDialog.FileTitle
     strTablename = Mid(frmMain.dlgCommonDialog.FileTitle, 1, Len(frmMain.dlgCommonDialog.FileTitle) - 3)
  End Select
   
  Else
    strConnect = ""
    strDatabase = ""
    strRecordsource = ""
    strTablename = ""
   Exit Sub
 End If
       
  Screen.MousePointer = 0
  
  Exit Sub
  
ErrorHandling:
 Screen.MousePointer = 0
 Select Case Err.Number
  Case 3274
   MsgBox "Table " & strTablename & " has wrong format!", vbCritical + vbOKOnly, "Error"
  Case 32755 'Abbrechen wurde ausgewhlt
   Exit Sub
  Case Else
   MsgBox "Following error has occured:" & vbCrLf & _
          "Number: " & Err.Number & vbCrLf & _
          "Description: " & Err.Description, vbCritical + vbOKOnly, "Error"
 End Select
    strConnect = ""
    strDatabase = ""
    strRecordsource = ""
    strTablename = ""
 
      
End Sub

Public Sub ComputeSMR(ProjectName As String, level As String, sex As Integer, rate As String)
 
 Dim lngTote As Long
 Dim dblExp As Double
 Dim i As Long
 Dim j As Long
 Dim k As Long
 Dim l As Long
 Dim Smr As Double
 Dim Smr_l As Double
 Dim Smr_h As Double
 Dim Alpha As Single
  
 Select Case level
  Case "0.01"
   Alpha = 2.5758
  Case "0.05"
   Alpha = 1.96
  Case "0.10"
   Alpha = 1.6449
 End Select
 
 
 'Berechnung der Gesamtanzahl von Toten
  For i = 1 To maxAgeClass - 1
   For j = 1 To maxYearClass - 1
    lngTote = lngTote + dth(i, j)
    Next j
  Next i
    
  With frmMain.DataInternal
   .DatabaseName = strTempPamFile
   .RecordSource = "PamPyValues"
   .Refresh
    
   ReDim py(3, maxAgeClass - 1, maxYearClass - 1) As Long
   .Recordset.MoveFirst
   For k = 1 To intAnzahlTables
    For i = 1 To maxAgeClass - 1
     For j = 1 To maxYearClass - 1
     py(k, i, j) = .Recordset.fields("PersonYears")
     .Recordset.MoveNext
     Next j
    Next i
   Next k
 End With
   
  
  'Berechnung der Gesamt Person-Years
  For i = 1 To maxAgeClass - 1
   For j = 1 To maxYearClass - 1
    Project.totPy = Project.totPy + py(sex, i, j)
   Next j
  Next i
  
  Project.totPy = Project.totPy / 365.25
  
  With frmMain.DataInternal
   .DatabaseName = strTempPamFile
   .RecordSource = rate
   .Refresh
  End With
 
  k = frmMain.DataInternal.Recordset.RecordCount
  l = frmMain.DataInternal.Recordset.fields.Count
     
  ReDim Raten(k, l) As Double
  
  frmMain.DataInternal.Recordset.MoveFirst
  For i = 1 To k
    For j = 1 To l
      Raten(i, j) = frmMain.DataInternal.Recordset.fields(j - 1)
    Next j
     frmMain.DataInternal.Recordset.MoveNext
  Next i
  
    
     
  'Berechnung der erwarteten Todesflle
    For i = 1 To maxAgeClass - 1
     For j = 1 To maxYearClass - 1
      dblExp = dblExp + (py(sex, i, j) / 365.25) * Raten(i, j)
     Next j
    Next i
    
    If dblExp = 0 Then
     MsgBox strMSG(36), vbOKOnly + vbExclamation, "Warning"
      If lngTote > 0 Then
       Project.n = frmMain.DataMain.Recordset.RecordCount
       Project.NInc = varNInc
       Project.totTote = lngTote
       Project.Expected = dblExp
       Project.totDthRate = lngTote / Project.totPy
       Project.Alpha = level
       Project.Smr = 0
       Project.Smr_l = 0
       Project.Smr_h = 0
      Else
       MsgBox strMSG(37), vbOKOnly + vbExclamation, "Warning"
       Project.n = frmMain.DataMain.Recordset.RecordCount
       Project.NInc = varNInc
       Project.totTote = 0
       Project.Expected = 0
       Project.totDthRate = 0
       Project.Alpha = level
       Project.Smr = 0
       Project.Smr_l = 0
       Project.Smr_h = 0
     End If
     Exit Sub
    End If
    
   If lngTote > 0 Then
    Project.n = frmMain.DataMain.Recordset.RecordCount
    Project.NInc = varNInc
    Project.totTote = lngTote
    Project.Expected = dblExp
    Project.totDthRate = lngTote / Project.totPy
    Project.Alpha = level
    Project.Smr = (lngTote / dblExp) * 100
    Project.Smr_l = Project.Smr * (1 - (1 / (9 * lngTote)) - Alpha / (3 * Sqr(lngTote))) ^ 3
    Project.Smr_h = Project.Smr * ((lngTote + 1) / lngTote) * (1 - (1 / (9 * (lngTote + 1))) + Alpha / (3 * Sqr(lngTote + 1))) ^ 3
   Else
    MsgBox strMSG(37), vbOKOnly + vbExclamation, "Warning"
    Project.n = frmMain.DataMain.Recordset.RecordCount
    Project.NInc = varNInc
    Project.totTote = 0
    Project.Expected = 0
    Project.totDthRate = 0
    Project.Alpha = level
    Project.Smr = 0
    Project.Smr_l = 0
    Project.Smr_h = 0
   End If
   
    
End Sub

Public Sub ShowSMR(tabelle As String)
Dim i As Long
Dim j As Long
Dim dummy As String


With frmMain.DataInternal
 .DatabaseName = strTempPamFile
 .RecordSource = tabelle
 .Refresh
End With


frmMain.ResultGrid.Cols = 2
frmMain.ResultGrid.Rows = 13

frmMain.ResultGrid.TextMatrix(0, 0) = ""
frmMain.ResultGrid.TextMatrix(0, 1) = "Values"
 
frmMain.ResultGrid.ColWidth(0) = 1500

frmMain.ResultGrid.TextMatrix(1, 0) = "N"
frmMain.ResultGrid.TextMatrix(2, 0) = "N included"
frmMain.ResultGrid.TextMatrix(3, 0) = "Lag years"
frmMain.ResultGrid.TextMatrix(4, 0) = "ICD code"
frmMain.ResultGrid.TextMatrix(5, 0) = "Deaths observed"
frmMain.ResultGrid.TextMatrix(6, 0) = "Deaths expected"
frmMain.ResultGrid.TextMatrix(7, 0) = "Person years"
frmMain.ResultGrid.TextMatrix(8, 0) = "Death rate"
frmMain.ResultGrid.TextMatrix(9, 0) = "CI low"
frmMain.ResultGrid.TextMatrix(10, 0) = "SMR"
frmMain.ResultGrid.TextMatrix(11, 0) = "CI high"
frmMain.ResultGrid.TextMatrix(12, 0) = "Alpha"

With frmMain.DataInternal
 dummy = .Recordset.fields("Values")
 .Recordset.MoveNext
 dummy = .Recordset.fields("Values")
 .Recordset.MoveNext
 dummy = .Recordset.fields("Values")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(12, 1) = .Recordset.fields("Values")
 .Recordset.MoveNext
 dummy = .Recordset.fields("Values")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(4, 1) = .Recordset.fields("Values")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(5, 1) = .Recordset.fields("Values")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(7, 1) = Format(.Recordset.fields("Values"), "0.00;;0")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(8, 1) = Format(.Recordset.fields("Values"), "0.000000;;0")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(6, 1) = Format(.Recordset.fields("Values"), "0.00;;0")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(10, 1) = Format(.Recordset.fields("Values"), "0.00;;0")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(9, 1) = Format(.Recordset.fields("Values"), "0.00;;0")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(11, 1) = Format(.Recordset.fields("Values"), "0.00;;0")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(1, 1) = .Recordset.fields("Values")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(2, 1) = .Recordset.fields("Values")
 .Recordset.MoveNext
 frmMain.ResultGrid.TextMatrix(3, 1) = .Recordset.fields("Values")
End With
  
If frmMain.ResultGrid.Rows >= 8 Then
 frmMain.ResultGrid.Row = 9
 frmMain.ResultGrid.CellBackColor = vbGreen
 frmMain.ResultGrid.CellForeColor = vbBlack
End If
If frmMain.ResultGrid.Rows >= 9 Then
 frmMain.ResultGrid.Row = 10
 frmMain.ResultGrid.CellBackColor = vbRed
 frmMain.ResultGrid.CellForeColor = vbBlack
End If
If frmMain.ResultGrid.Rows >= 10 Then
 frmMain.ResultGrid.Row = 11
 frmMain.ResultGrid.CellBackColor = vbGreen
 frmMain.ResultGrid.CellForeColor = vbBlack
End If


Call ShowTables("ResultGrid")

End Sub



Public Sub ClearVariables()

frmMain.Navigator.Nodes.Clear
Set nodeX = frmMain.Navigator.Nodes.Add(, , "Main", "Main", 1, 2)
Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "DATA", "Data", 1, 2)
Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "RATE", "Rate tables", 1, 2)
Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "PY", "Person-Years", 1)
  
blnTextImport = False
strMainTable = ""
intRateTablesAnzahl = 0
strDatabase = ""
strRecordsource = ""
strConnect = ""
strTablename = ""
AgeCalendarKey = ""
Sex1AgeCalendarKey = ""
Sex2AgeCalendarKey = ""
DeathKey = ""
selectedTable = ""
blnPAMFileLoad = False
strPamFile = ""
strTempPamFile = ""
blnPersonYears = False
blnSex = False
blnLag = False
varSexStatus = False
varLagStatus = False
intAnzahlTables = 0
intProjectAnzahl = 0
ReDim SpaltenNamen(0) As String
varEPS = ""
varTPS = ""
varDOB = ""
varSEX = ""
varSex1 = 0
varSex2 = 0
varAgeFrom = 0
varAgeTo = 0
varAgeStep = 0
maxAgeClass = 0
blnAgeSelfDefined = False
ReDim ageclass(0) As Integer
varCalendarFrom = 0
varCalendarTo = 0
varCalendarStep = 0
maxYearClass = 0
blnCalendarSelfDefined = False
ReDim yearclass(0) As Integer
ReDim py(0) As Long
ReDim dth(0) As Long
ReDim tempPy(0) As Long
varLag = 0
varDOH = ""
blnProgress = False
varNInc = 0

End Sub





Public Sub SavePamFile_v10()
 Dim i As Long
 Dim j As Long
 Dim k As Long
 
 With frmMain.DataInternal
  .DatabaseName = strTempPamFile
  .RecordSource = "PamSystemMain"
  .Refresh
   
   .Recordset.MoveFirst
   .Recordset.Edit
   .Recordset.fields("Value") = strPAMFileVersion
   .Recordset.Update
   .Recordset.MoveNext
   .Recordset.Edit
   .Recordset.fields("Value") = strMainTable
   .Recordset.Update
   .Recordset.MoveNext
   .Recordset.Edit
   .Recordset.fields("Value") = intRateTablesAnzahl
   .Recordset.Update
   .Recordset.MoveNext
   .Recordset.Edit
   .Recordset.fields("Value") = intProjectAnzahl
   .Recordset.Update
 End With
    

 With frmMain.DataInternal
  .DatabaseName = strTempPamFile
  .RecordSource = "PamSystemPY"
  .Refresh
  
  .Recordset.MoveFirst
  .Recordset.Edit
  .Recordset.fields("Value") = blnPersonYears
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = intAnzahlTables
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varDOB
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varEPS
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varTPS
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varSEX
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = blnAgeSelfDefined
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = maxAgeClass
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varAgeFrom
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varAgeTo
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varAgeStep
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = blnCalendarSelfDefined
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = maxYearClass
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varCalendarFrom
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varCalendarTo
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varCalendarStep
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = blnSex
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varSexStatus
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varSex1
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varSex2
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = blnLag
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varLag
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varLagStatus
  .Recordset.Update
  .Recordset.MoveNext
  .Recordset.Edit
  .Recordset.fields("Value") = varDOH
  .Recordset.Update
 End With


If blnPersonYears = True Then
 With frmMain.DataInternal
   .DatabaseName = strTempPamFile
    
    
   .Database.TableDefs.Delete "PamAgeClassValues"
   .Database.Execute "CREATE TABLE PamAgeClassValues (AgeClass INTEGER);"
   
   .Database.TableDefs.Delete "PamYearClassValues"
   .Database.Execute "CREATE TABLE PamYearClassValues (YearClass INTEGER);"
   
   .Database.TableDefs.Delete "PamPyValues"
   .Database.Execute "CREATE TABLE PamPyValues (PersonYears LONG);"
   
   .RecordSource = "PamAgeClassValues"
   .Refresh
   
   
  For i = 1 To maxAgeClass
   .Recordset.AddNew
   .Recordset.fields("AgeClass") = ageclass(i)
   .Recordset.Update
  Next i
  
   .RecordSource = "PamYearClassValues"
   .Refresh
     
  For i = 1 To maxYearClass
   .Recordset.AddNew
   .Recordset.fields("YearClass") = yearclass(i)
   .Recordset.Update
  Next i
  
   .RecordSource = "PamPyValues"
   .Refresh
   
  For k = 1 To intAnzahlTables
   For i = 1 To maxAgeClass - 1
    For j = 1 To maxYearClass - 1
     .Recordset.AddNew
     .Recordset.fields("PersonYears") = py(k, i, j)
     .Recordset.Update
    Next j
   Next i
  Next k
 End With
End If



If frmMain.DataMain.DatabaseName <> "" Then frmMain.DataMain.Database.Close

If frmMain.DataInternal.DatabaseName <> "" Then frmMain.DataInternal.Database.Close
 
FileCopy strTempPamFile, strPamFile
 
With frmMain.DataMain
 .DatabaseName = strTempPamFile
 .RecordSource = strMainTable
 .Refresh
End With
  


End Sub

Public Function OpenPamFile_v10() As Boolean
'|-------------------------------------------|
'| ffnet eine PAMCOMP-Datei der Version 1.0 |
'|-------------------------------------------|
 On Error GoTo ErrorHandling
 
 Dim i As Long
 Dim j As Long
 Dim k As Long
 Dim dummy As String

  
 FileCopy strPamFile, strTempPamFile
  
 With frmMain.DataInternal
  .DatabaseName = strTempPamFile
  .RecordSource = "PamSystemMain"
  .Refresh
  
  .Recordset.MoveFirst
   dummy = .Recordset.fields("Value")
   If .Recordset.fields("Value") <> strPAMFileVersion Then
    MsgBox strMSG(1), vbOKOnly + vbCritical, "Error"
    frmMain.DataInternal.Database.Close
    Exit Function
   End If
  .Recordset.MoveNext
   strMainTable = .Recordset.fields("Value")
  .Recordset.MoveNext
   intRateTablesAnzahl = CInt(.Recordset.fields("Value"))
  .Recordset.MoveNext
   intProjectAnzahl = CInt(.Recordset.fields("Value"))
 End With
 
  
 If strMainTable <> "" Then
  With frmMain.DataMain
   .DatabaseName = strTempPamFile
   .RecordSource = strMainTable
   .Refresh
  End With
      
  Set nodeX = frmMain.Navigator.Nodes.Add("DATA", tvwChild, "Main_Data_" & strMainTable, strMainTable, 3)

 'Tabellenspalten der MainTable ermitteln
  
  ReDim SpaltenNamen(2, frmMain.DataMain.Recordset.fields.Count) As String
  For i = 1 To frmMain.DataMain.Recordset.fields.Count
   SpaltenNamen(1, i) = frmMain.DataMain.Recordset.fields(i - 1).Name
  Next i
  
 'Format der Spalten ermitteln
  For i = 1 To UBound(SpaltenNamen, 2)
   If IsNumeric(frmMain.DataMain.Recordset.fields(SpaltenNamen(1, i))) = True Then
    SpaltenNamen(2, i) = "numeric"
   End If
   If IsDate(frmMain.DataMain.Recordset.fields(SpaltenNamen(1, i))) = True Then
    SpaltenNamen(2, i) = "date"
   End If
  Next i
  
 End If
 
 If intRateTablesAnzahl > 0 Then
  With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = "PamSystemRateTables"
    .Refresh
    
    For i = 1 To intRateTablesAnzahl
     Set nodeX = frmMain.Navigator.Nodes.Add("RATE", tvwChild, , .Recordset.fields("RateTables"), 3)
     .Recordset.MoveNext
    Next i
  End With
 End If
  
  
If intProjectAnzahl > 0 Then
 With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = "PamSystemProjects"
    .Refresh
    
    For i = 1 To intProjectAnzahl
     dummy = .Recordset.fields("Projects")
     Set nodeX = frmMain.Navigator.Nodes.Add(, , dummy, dummy, 1)
     Set nodeX = frmMain.Navigator.Nodes.Add(dummy, tvwChild, , "Deaths", 3)
     Set nodeX = frmMain.Navigator.Nodes.Add(dummy, tvwChild, , "SMR table", 3)
     .Recordset.MoveNext
    Next i
  End With
End If
  
          
  With frmMain.DataInternal
   .DatabaseName = strTempPamFile
   .RecordSource = "PamSystemPY"
   .Refresh
 
   .Recordset.MoveFirst
    blnPersonYears = .Recordset.fields("Value")
   .Recordset.MoveNext
    intAnzahlTables = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varDOB = .Recordset.fields("Value")
   .Recordset.MoveNext
    varEPS = .Recordset.fields("Value")
   .Recordset.MoveNext
    varTPS = .Recordset.fields("Value")
   .Recordset.MoveNext
    varSEX = .Recordset.fields("Value")
   .Recordset.MoveNext
    blnAgeSelfDefined = .Recordset.fields("Value")
   .Recordset.MoveNext
    maxAgeClass = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varAgeFrom = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varAgeTo = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varAgeStep = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    blnCalendarSelfDefined = .Recordset.fields("Value")
   .Recordset.MoveNext
    maxYearClass = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varCalendarFrom = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varCalendarTo = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varCalendarStep = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    blnSex = .Recordset.fields("Value")
   .Recordset.MoveNext
    varSexStatus = .Recordset.fields("Value")
   .Recordset.MoveNext
    varSex1 = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varSex2 = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    blnLag = .Recordset.fields("Value")
   .Recordset.MoveNext
    varLag = CInt(.Recordset.fields("Value"))
   .Recordset.MoveNext
    varLagStatus = .Recordset.fields("Value")
   .Recordset.MoveNext
    varDOH = .Recordset.fields("Value")
  End With
    
      
If blnPersonYears = True Then
 With frmMain.DataInternal
  .DatabaseName = strTempPamFile
  .RecordSource = "PamAgeClassValues"
  .Refresh
     
  ReDim ageclass(maxAgeClass) As Integer
  .Recordset.MoveLast
  .Recordset.MoveFirst
  For i = 1 To .Recordset.RecordCount
   ageclass(i) = .Recordset.fields("AgeClass")
   .Recordset.MoveNext
  Next i

  .RecordSource = "PamYearClassValues"
  .Refresh
  
  ReDim yearclass(maxYearClass) As Integer
  .Recordset.MoveLast
  .Recordset.MoveFirst
  For i = 1 To .Recordset.RecordCount
   yearclass(i) = .Recordset.fields("YearClass")
   .Recordset.MoveNext
  Next i

  .RecordSource = "PamPyValues"
  .Refresh
    
  ReDim py(3, maxAgeClass - 1, maxYearClass - 1) As Long
  .Recordset.MoveFirst
  For k = 1 To intAnzahlTables
   For i = 1 To maxAgeClass - 1
    For j = 1 To maxYearClass - 1
     py(k, i, j) = .Recordset.fields("PersonYears")
     .Recordset.MoveNext
    Next j
   Next i
  Next k
 End With
  
 If intAnzahlTables = 1 Then
  AgeCalendarKey = "PYAgeCalendarKey"
  Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, AgeCalendarKey, "Age*Calendar", 3)
 Else
  AgeCalendarKey = "PYAgeCalendarKey"
  Sex1AgeCalendarKey = "PYSex1AgeCalendarKey"
  Sex2AgeCalendarKey = "PYSex2AgeCalendarKey"
  Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, AgeCalendarKey, "Age*Calendar", 3)
  Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, Sex1AgeCalendarKey, "Age*Calendar*Sex=" & varSex1, 3)
  Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, Sex2AgeCalendarKey, "Age*Calendar*Sex=" & varSex2, 3)
 End If
End If

OpenPamFile_v10 = True
Exit Function

ErrorHandling:
 Screen.MousePointer = 0
 Select Case Err.Number
  Case 3343
   MsgBox strPamFile & " is not a PAMCOMP file!", vbCritical + vbOKOnly, "Error"
  Case Else
   MsgBox "Following error has occured:" & vbCrLf & _
          "Number: " & Err.Number & vbCrLf & _
          "Description: " & Err.Description, vbCritical + vbOKOnly, "Error"
  End Select
  OpenPamFile_v10 = False
End Function







Public Sub RefreshNodes()
'|----------------------------------|
'| Zeichnet die Knoten im Navigator |
'|----------------------------------|

 Dim i As Integer
 Dim dummy As String
 
 Screen.MousePointer = 11
 
 frmMain.Navigator.Nodes.Clear
 
  Set nodeX = frmMain.Navigator.Nodes.Add(, , "Main", "Main", 1, 2)
  Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "DATA", "Data", 1, 2)
  Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "RATE", "Rate tables", 1, 2)
  Set nodeX = frmMain.Navigator.Nodes.Add("Main", tvwChild, "PY", "Person-Years", 1)
  
  With frmMain.DataMain
   .DatabaseName = strTempPamFile
   .RecordSource = strMainTable
   .Refresh
  End With
  Set nodeX = frmMain.Navigator.Nodes.Add("DATA", tvwChild, "Main_Data_" & strMainTable, strMainTable, 3)
  
  If intRateTablesAnzahl > 0 Then
  With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = "PamSystemRateTables"
    .Refresh
    
    For i = 1 To intRateTablesAnzahl
     Set nodeX = frmMain.Navigator.Nodes.Add("RATE", tvwChild, , .Recordset.fields("RateTables"), 3)
     .Recordset.MoveNext
    Next i
  End With
 End If
  
  
If intProjectAnzahl > 0 Then
 With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = "PamSystemProjects"
    .Refresh
    
    For i = 1 To intProjectAnzahl
     dummy = .Recordset.fields("Projects")
     Set nodeX = frmMain.Navigator.Nodes.Add(, , dummy, dummy, 1)
     Set nodeX = frmMain.Navigator.Nodes.Add(dummy, tvwChild, , "Deaths", 3)
     Set nodeX = frmMain.Navigator.Nodes.Add(dummy, tvwChild, , "SMR table", 3)
     .Recordset.MoveNext
    Next i
  End With
End If

If blnPersonYears = True Then
  If intAnzahlTables = 1 Then
   AgeCalendarKey = "PYAgeCalendarKey"
   Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, AgeCalendarKey, "Age*Calendar", 3)
  Else
   AgeCalendarKey = "PYAgeCalendarKey"
   Sex1AgeCalendarKey = "PYSex1AgeCalendarKey"
   Sex2AgeCalendarKey = "PYSex2AgeCalendarKey"
   Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, AgeCalendarKey, "Age*Calendar", 3)
   Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, Sex1AgeCalendarKey, "Age*Calendar*Sex=" & varSex1, 3)
   Set nodeX = frmMain.Navigator.Nodes.Add("PY", tvwChild, Sex2AgeCalendarKey, "Age*Calendar*Sex=" & varSex2, 3)
  End If
End If

Screen.MousePointer = 0

End Sub

Public Sub ComputePersonYears_DLL()
'|---------------------------------------|
'| Berchnet die Person-Years mit Hilfe   |
'| der pamcomp.dll                       |
'|---------------------------------------|

 Dim datum1 As Double
 Dim datum2 As Double
 Dim datum3 As Double
 Dim datum4 As Date
 Dim sex As Long
 Dim anzahl As Long
 Dim k As Long
 Dim i As Long
 Dim j As Long
 Dim l As Long
 

 
 '*** yearclass() in andere Form umwandeln fr die DLL
 '*** d.h. aus z.B. 1981 den 1/1/1981 machen
 ReDim dll_yearclass(maxYearClass) As Double
 For i = 1 To maxYearClass
  dll_yearclass(i) = DateSerial(yearclass(i), 1, 1)
 Next i
 
 '*** ageclass() in double Variable umwandeln fr die DLL
 ReDim dll_ageclass(maxAgeClass) As Double
 For i = 1 To maxAgeClass
  dll_ageclass(i) = CDbl(ageclass(i))
 Next i
 
 '*** Array, da die PY zurckgibt, pro Aufruf der DLL.
 ReDim dllpy((maxAgeClass - 1) * (maxYearClass - 1)) As Double
   
 If blnSex = True Then
  '*** Array, da die Summe der PY der Mnner aufnimmt
  ReDim dllPytemp1((maxAgeClass - 1) * (maxYearClass - 1)) As Double
  '*** Array, da die Summe der PY der Frauen aufnimmt
  ReDim dllPytemp2((maxAgeClass - 1) * (maxYearClass - 1)) As Double
 Else
 '*** Array, da die Summe der PY aufnimmt (nicht geschlechtsspezifisch)
  ReDim dllPytemp((maxAgeClass - 1) * (maxYearClass - 1)) As Double
 End If
 
 '*** Globales Array, da die PY aus der SUB zurckgibt
 ReDim tempPy(3, maxAgeClass - 1, maxYearClass - 1) As Long
  
 frmMain.DataMain.Recordset.MoveLast
  anzahl = frmMain.DataMain.Recordset.RecordCount
 frmMain.DataMain.Recordset.MoveFirst
 
 
 
 DoEvents
  
 
  For k = 1 To anzahl
   If frmProgress.Timer1 = True Then
    DoEvents
    If ProgressCancel = True Then Exit Sub
   End If
   frmProgress.ProgressBar1.Value = (frmMain.DataMain.Recordset.PercentPosition * 4)
   
   datum1 = frmMain.DataMain.Recordset.fields(varEPS)
   datum2 = frmMain.DataMain.Recordset.fields(varTPS)
   datum3 = frmMain.DataMain.Recordset.fields(varDOB)
   
    
   '*** der LAG
   If varLag > 0 Then
    datum4 = DateAdd("yyyy", varLag, frmMain.DataMain.Recordset.fields(varDOH))
    If CDbl(datum4) > datum1 Then datum1 = CDbl(datum4)
   End If
   
   
   If blnSex = True Then
     If varSex1 = frmMain.DataMain.Recordset.fields(varSEX) Then sex = 2        'Mnner
     If varSex2 = frmMain.DataMain.Recordset.fields(varSEX) Then sex = 3        'Frauen
   Else
     sex = 1                                                                    'Mnner & Frauen
   End If
         
   '*** DLL aufrufen
   Call PYCOMPUTE(datum1, datum2, datum3, dllpy(0), (maxAgeClass - 1) * (maxYearClass - 1), _
                  dll_ageclass(0), maxAgeClass - 1, dll_yearclass(0), maxYearClass - 1)
   
 
 '*** PY aufsummieren
 If blnSex = True Then '*** Nach Geschlecht stratifiziert
  If sex = 2 Then   '*** Mnner
   For l = 1 To (maxAgeClass - 1) * (maxYearClass - 1)
    dllPytemp1(l) = dllPytemp1(l) + dllpy(l)
   Next l
  End If
  If sex = 3 Then   '*** Frauen
   For l = 1 To (maxAgeClass - 1) * (maxYearClass - 1)
   dllPytemp2(l) = dllPytemp2(l) + dllpy(l)
   Next l
  End If
 Else  '*** Unabhngig vom Geschlecht
   For l = 1 To (maxAgeClass - 1) * (maxYearClass - 1)
    dllPytemp(l) = dllPytemp(l) + dllpy(l)
   Next l
 End If
 
  
 frmMain.DataMain.Recordset.MoveNext
 Next k
 
    
 '*** PY in das globale Array tempPy() speichern
 l = 1
 If blnSex = True Then
  'Mnner und Frauen
  For j = 1 To maxYearClass - 1
   For i = 1 To maxAgeClass - 1
    tempPy(1, i, j) = dllPytemp1(l) + dllPytemp2(l)
    l = l + 1
   Next i
  Next j
  'Mnner
  l = 1
  For j = 1 To maxYearClass - 1
   For i = 1 To maxAgeClass - 1
    tempPy(2, i, j) = dllPytemp1(l)
    l = l + 1
   Next i
  Next j
  'Frauen
  l = 1
  For j = 1 To maxYearClass - 1
   For i = 1 To maxAgeClass - 1
    tempPy(3, i, j) = dllPytemp2(l)
    l = l + 1
   Next i
  Next j
 'keine Stratifizierung nach Geschlecht
 Else
  For j = 1 To maxYearClass - 1
   For i = 1 To maxAgeClass - 1
    tempPy(1, i, j) = dllPytemp(l)
     l = l + 1
   Next i
  Next j
 End If
  
 blnPersonYears = True

End Sub

Public Sub ComputeDeaths_DLL(ProjectName As String, tabelle As Integer, tmpLag As Integer)
   
 Dim datum1 As Double
 Dim datum2 As Double
 Dim sex As Long
 Dim i As Long
 Dim j As Long
 Dim k As Long
 Dim l As Long
 Dim anzahl As Long
 Dim blnAdd As Boolean
  
 DoEvents
 
 If tabelle = 1 Then sex = 0
 If tabelle = 2 Then sex = varSex1
 If tabelle = 3 Then sex = varSex2
 
 
 '*** yearclass() in andere Form umwandeln fr die DLL
 '*** d.h. aus z.B. 1981 den 1/1/1981 machen
 ReDim dll_yearclass(maxYearClass) As Double
 For i = 1 To maxYearClass
  dll_yearclass(i) = DateSerial(yearclass(i), 1, 1)
 Next i
 
 '*** ageclass() in double Variable umwandeln fr die DLL
 ReDim dll_ageclass(maxAgeClass) As Double
 For i = 1 To maxAgeClass
  dll_ageclass(i) = CDbl(ageclass(i))
 Next i
  
 '*** Array, da die Todeszahlen zurckgibt, pro Aufruf der DLL.
 ReDim dlldth((maxAgeClass - 1) * (maxYearClass - 1)) As Double
 
 '*** Array, da die Summe der Todeszahlen aufnimmt
  ReDim dllDthtemp((maxAgeClass - 1) * (maxYearClass - 1)) As Double
 
 
 '*** Globales Array fr die Rckgabe der Todeszahlen aus der SUB
 ReDim dth(maxAgeClass - 1, maxYearClass - 1) As Long
 

 frmMain.DataMain.Recordset.MoveLast
 anzahl = frmMain.DataMain.Recordset.RecordCount
 frmMain.DataMain.Recordset.MoveFirst
 
 If tmpLag = 0 Then varNInc = anzahl
  
  
 For k = 1 To anzahl
  
 If frmProgress.Timer1 = True Then
   DoEvents
   If ProgressCancel = True Then Exit Sub
 End If
  
  
 frmProgress.ProgressBar1.Value = (frmMain.DataMain.Recordset.PercentPosition * 4)
 
  
 'Lag
 If tmpLag > 0 Then
  If DateAdd("yyyy", tmpLag, frmMain.DataMain.Recordset.fields(varDOH)) >= frmMain.DataMain.Recordset.fields(varTPS) Then
   blnAdd = False    'Keinen Todesfall hinzufgen, da doh+lag >= tps
  Else
   blnAdd = True
   varNInc = varNInc + 1  'Anzahl der Personen, die in die Berechnung mit einbezogen werden , d.h. PY > 0
  End If
 Else 'tmpLag=0
   blnAdd = True
 End If
  
 Select Case tabelle
  Case 1  'Nicht nach Geschlecht stratifiziert
   If frmMain.DataMain.Recordset.fields(Project.varDTH) = Project.varTod And blnAdd = True Then
    datum1 = frmMain.DataMain.Recordset.fields(varTPS)
    datum2 = frmMain.DataMain.Recordset.fields(varDOB)
    
  '*** DLL aufrufen
  Call DEATHCOMPUTE(datum1, datum2, dlldth(0), (maxAgeClass - 1) * (maxYearClass - 1), _
                     dll_ageclass(0), maxAgeClass - 1, dll_yearclass(0), maxYearClass - 1)

  '*** Todeszahlen aufsummieren
   For l = 1 To (maxAgeClass - 1) * (maxYearClass - 1)
    dllDthtemp(l) = dllDthtemp(l) + dlldth(l)
   Next l
  
   End If
 Case 2, 3   'Nach Geschlecht stratifiziert
    If frmMain.DataMain.Recordset.fields(Project.varDTH) = Project.varTod And blnAdd = True And _
      frmMain.DataMain.Recordset.fields(varSEX) = sex Then
     datum1 = frmMain.DataMain.Recordset.fields(varTPS)
     datum2 = frmMain.DataMain.Recordset.fields(varDOB)
      
     '*** DLL aufrufen
     Call DEATHCOMPUTE(datum1, datum2, dlldth(0), (maxAgeClass - 1) * (maxYearClass - 1), _
                      dll_ageclass(0), maxAgeClass - 1, dll_yearclass(0), maxYearClass - 1)

     '*** Todeszahlen aufsummieren
     For l = 1 To (maxAgeClass - 1) * (maxYearClass - 1)
      dllDthtemp(l) = dllDthtemp(l) + dlldth(l)
     Next l
     
      
    End If
  End Select
    
  frmMain.DataMain.Recordset.MoveNext
 Next k
   
 l = 1
 For j = 1 To maxYearClass - 1
   For i = 1 To maxAgeClass - 1
    dth(i, j) = dth(i, j) + dllDthtemp(l)
    l = l + 1
   Next i
  Next j
   

End Sub
