VERSION 5.00
Begin VB.Form frmSMRComp 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SMR Computation"
   ClientHeight    =   4395
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   6255
   Icon            =   "frmSMRComp.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4395
   ScaleWidth      =   6255
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton btnCompute 
      Caption         =   "Compute"
      Height          =   450
      Left            =   4770
      TabIndex        =   12
      Top             =   3750
      Width           =   1080
   End
   Begin VB.CommandButton btnCancel 
      Caption         =   "Cancel"
      Height          =   450
      Left            =   3360
      TabIndex        =   11
      Top             =   3750
      Width           =   1080
   End
   Begin VB.Frame Frame1 
      Caption         =   "Deaths"
      Height          =   1530
      Left            =   225
      TabIndex        =   6
      Top             =   1815
      Width           =   3570
      Begin VB.ComboBox comDTH 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   420
         Width           =   2235
      End
      Begin VB.TextBox txtDTHValues 
         Height          =   315
         Left            =   1200
         TabIndex        =   7
         Top             =   960
         Width           =   1965
      End
      Begin VB.Label Label1 
         Caption         =   "ICD variable:"
         Height          =   300
         Left            =   165
         TabIndex        =   10
         Top             =   435
         Width           =   915
      End
      Begin VB.Label Label2 
         Caption         =   "ICD value:"
         Height          =   300
         Left            =   165
         TabIndex        =   9
         Top             =   967
         Width           =   870
      End
   End
   Begin VB.ComboBox comPyTable 
      Height          =   315
      Left            =   210
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1245
      Width           =   3450
   End
   Begin VB.ComboBox comRateTable 
      Height          =   315
      Left            =   210
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   480
      Width           =   3450
   End
   Begin VB.Frame Frame2 
      Caption         =   "Significance level"
      Height          =   915
      Left            =   4275
      TabIndex        =   1
      Top             =   2430
      Width           =   1575
      Begin VB.ComboBox comSigLevel 
         Height          =   315
         Left            =   150
         Style           =   2  'Dropdown List
         TabIndex        =   2
         Top             =   330
         Width           =   870
      End
   End
   Begin VB.Label Label4 
      Caption         =   "Person-Years table:"
      Height          =   240
      Left            =   225
      TabIndex        =   3
      Top             =   930
      Width           =   1590
   End
   Begin VB.Label Label3 
      Caption         =   "Rate file:"
      Height          =   225
      Left            =   225
      TabIndex        =   0
      Top             =   210
      Width           =   795
   End
End
Attribute VB_Name = "frmSMRComp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  
  Dim UserCancel As Boolean  'Gibt an , ob User gecancelt hat (=true) oder nicht




Private Sub btnCancel_Click()
 UserCancel = True
 Unload Me
End Sub

Private Sub btnCompute_Click()
 Dim i As Long
 Dim j As Long
 
 
'Werte initialisieren
 Project.RateTable = ""
 Project.PyTable = 0
 Project.Alpha = ""
 Project.varDTH = ""
 Project.varTod = 0
 Project.totTote = 0
 Project.totPy = 0
 Project.totDthRate = 0
 Project.Expected = 0
 Project.Smr = 0
 Project.Smr_l = 0
 Project.Smr_h = 0
 Project.n = 0
 Project.NInc = 0
 varNInc = 0
 Project.varLag = 0


 
 If comRateTable.Text = "" Then
   MsgBox strMSG(28), vbOKOnly + vbCritical, "Error"
   Exit Sub
 End If
    
 If comPyTable.Text = "" Then
   MsgBox strMSG(29), vbOKOnly + vbCritical, "Error"
   Exit Sub
 End If
    
 If comDTH.Text = "" Then
   MsgBox strMSG(30), vbOKOnly + vbCritical, "Error"
   Exit Sub
 End If
  
  For i = 1 To UBound(SpaltenNamen, 2)
   If comDTH.Text = SpaltenNamen(1, i) Then
    If SpaltenNamen(2, i) <> "numeric" Then
     MsgBox strMSG(31), vbOKOnly + vbCritical, "Error"
     comDTH.SetFocus
     Exit Sub
    End If
   End If
  Next i
       
  If IsNumeric(txtDTHValues.Text) = False Then
   MsgBox strMSG(32), vbOKOnly + vbCritical, "Error"
   Exit Sub
  End If
  
  If Val(txtDTHValues.Text) < 0 Or Val(txtDTHValues.Text) > 32767 Then
   MsgBox strMSG(33), vbOKOnly + vbCritical, "Error"
   Exit Sub
  End If
  
  
  Project.RateTable = comRateTable.List(comRateTable.ListIndex)
  Project.PyTable = comPyTable.ListIndex + 1
  Project.Alpha = comSigLevel.Text
  Project.varDTH = comDTH.Text
  Project.varTod = Val(txtDTHValues.Text)
  If blnLag = True Then Project.varLag = varLag
  
  'RatenDatei einlesen
   With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = Project.RateTable
    .Refresh
  End With
      
  If frmMain.DataInternal.Recordset.RecordCount <> (maxAgeClass - 1) Or frmMain.DataInternal.Recordset.fields.Count <> (maxYearClass - 1) Then
   MsgBox strMSG(34), vbOKOnly + vbCritical, "Error"
   Exit Sub
  End If
  
  UserCancel = False
      
  Unload Me
  
  ShowTables ("Empty")
 
  Screen.MousePointer = 11
    
   
  With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = "PamSystemProjects"
    .Refresh
    
    .Recordset.AddNew
    .Recordset.fields("Projects") = Project.ProjectName
    .Recordset.Update
  End With
  
  frmProgress.Show 0, frmMain
  frmProgress.Label1 = "Computing Deaths"
  frmProgress.btnCancel.Enabled = False
  blnProgress = True
     
  Call ComputeDeaths_DLL(Project.ProjectName, Project.PyTable, Project.varLag)
  
  frmProgress.Label1 = "Computing SMR"
  Call ComputeSMR(Project.ProjectName, Project.Alpha, Project.PyTable, Project.RateTable)
 
 
 
  With frmMain.DataInternal
  .DatabaseName = strTempPamFile
  .Database.Execute "CREATE TABLE " & Project.ProjectName & "_Deaths (Deaths LONG);"
  .Database.Execute "CREATE TABLE " & Project.ProjectName & "_SMR (Typ TEXT, Values TEXT);"
  .RecordSource = Project.ProjectName & "_Deaths"
  .Refresh
   
  For i = 1 To maxAgeClass - 1
   For j = 1 To maxYearClass - 1
    .Recordset.AddNew
    .Recordset.fields("Deaths") = dth(i, j)
    .Recordset.Update
   Next j
  Next i
  
   .RecordSource = Project.ProjectName & "_SMR"
   .Refresh
    
   .Recordset.AddNew
   .Recordset.fields("Typ") = "ProjectName"
   .Recordset.fields("Values") = Project.ProjectName
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "RateTable"
   .Recordset.fields("Values") = Project.RateTable
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "PyTable"
   .Recordset.fields("Values") = CStr(Project.PyTable)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "Alpha"
   .Recordset.fields("Values") = Project.Alpha
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "varDTH"
   .Recordset.fields("Values") = Project.varDTH
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "varTod"
   .Recordset.fields("Values") = Project.varTod
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "totTote"
   .Recordset.fields("Values") = CStr(Project.totTote)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "totPy"
   .Recordset.fields("Values") = CStr(Project.totPy)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "totDthRate"
   .Recordset.fields("Values") = CStr(Project.totDthRate)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "Expected"
   .Recordset.fields("Values") = CStr(Project.Expected)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "Smr"
   .Recordset.fields("Values") = CStr(Project.Smr)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "Smr_l"
   .Recordset.fields("Values") = CStr(Project.Smr_l)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "Smr_h"
   .Recordset.fields("Values") = CStr(Project.Smr_h)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "N"
   .Recordset.fields("Values") = CStr(Project.n)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "NInc"
   .Recordset.fields("Values") = CStr(Project.NInc)
   .Recordset.Update
   .Recordset.AddNew
   .Recordset.fields("Typ") = "Lag"
   .Recordset.fields("Values") = CStr(Project.varLag)
   .Recordset.Update
 End With
  
 Set nodeX = frmMain.Navigator.Nodes.Add(, , Project.ProjectName, Project.ProjectName, 1)
 Set nodeX = frmMain.Navigator.Nodes.Add(Project.ProjectName, tvwChild, , "Deaths", 3)
 Set nodeX = frmMain.Navigator.Nodes.Add(Project.ProjectName, tvwChild, , "SMR table", 3)

  
 Unload frmProgress
  
 Screen.MousePointer = 0
End Sub


Private Sub Form_Load()
 Dim i As Integer
 Dim dummy As Integer
 
 Screen.MousePointer = 11
   
 If intRateTablesAnzahl > 0 Then
  With frmMain.DataInternal
    .DatabaseName = strTempPamFile
    .RecordSource = "PamSystemRateTables"
    .Refresh
    
    For i = 1 To intRateTablesAnzahl
      comRateTable.AddItem .Recordset.fields("RateTables")
      .Recordset.MoveNext
    Next i
  End With
 End If
  
 Call ShowTables("Empty")
 
 dummy = UBound(SpaltenNamen, 2)
 For i = 1 To dummy
  comDTH.AddItem SpaltenNamen(1, i)
 Next i
 
 If blnSex = True Then
  comPyTable.AddItem "Age*Calendar"
  comPyTable.AddItem "Age*Calendar*Sex=" & varSex1
  comPyTable.AddItem "Age*Calendar*Sex=" & varSex2
 Else
  comPyTable.AddItem "Age*Calendar"
 End If
  
 comSigLevel.AddItem "0.01"
 comSigLevel.AddItem "0.05"
 comSigLevel.AddItem "0.10"
 comSigLevel.ListIndex = 1
    
 Screen.MousePointer = 0
 
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
 If UnloadMode = vbFormControlMenu Then UserCancel = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
 If UserCancel = True Then
  intProjectAnzahl = intProjectAnzahl - 1
  If intProjectAnzahl < 0 Then intProjectAnzahl = 0
 End If
End Sub


